DEBUG = false;
function myAlert(msg) { 
    if (DEBUG) {
	alert(msg);
    }
}

var onQuit = {
    prefs: false,
    started: false,
    // The "load" event on window. 
    handleEvent: function()
    {
	try {
	    window.removeEventListener("load", onQuit, true);
	    if (!this.started) {
		var observerService = Components.
		    classes["@mozilla.org/observer-service;1"].
		    getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, 
		    "quit-application-requested", false);
		this.started = true;
	    }
	} catch(e) {myAlert(e);}
    },
    observe: function(aSubject, aTopic, aData)
    {
	try {
	    if (aTopic == "quit-application-requested") {
		if (this.ifPref("hashao.onquit.clearcache"))
		    cacheObj.clearCache();
		if (this.ifPref("hashao.onquit.clearhistory"))
		    histObj.clearHistory();
		if (this.ifPref("hashao.onquit.clearallcockies"))
		    cockieObj.clearAllCockies();
		myAlert("Done");
	    }
	} catch(e) { myAlert(e);}
    },
    ifPref: function(prefName) {
	if (!this.prefs) {
	   this.prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);
	}
	try {
	    return this.prefs.getBoolPref(prefName);
	} catch(e) {
	    return false;
	}
    },
}
var cacheObj = {
    clearCache: function() {
	try {
	    var classID = Components.
		classes["@mozilla.org/network/cache-service;1"];
	    var cacheService = classID.
		    getService(Components.interfaces.nsICacheService);
	    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ANYWHERE);
	    // cacheService.evictEntries(Components.
		//interfaces.nsICache.STORE_IN_MEMORY);
	    // cacheService.evictEntries(Components.
		//interfaces.nsICache.STORE_ON_DISK);
	} catch(e) {myAlert(e);}
    },
}

var histObj = {
    clearHistory: function() {
	try {
	    var gGlobalHistory = Components.
		classes["@mozilla.org/browser/global-history;2"].
		getService(Components.interfaces.nsIBrowserHistory);
	    gGlobalHistory.removeAllPages();
	} catch(e) {myAlert(e);}
    },
}

var cockieObj = {
    clearAllCockies: function() {
	try {
	    var cockieJar = Components.
		classes["@mozilla.org/cookiemanager;1"].
		getService(Components.interfaces.nsICookieManager);
	    cockieJar.removeAll();
	} catch(e) {myAlert(e);}
    },
}
window.addEventListener("load", onQuit, true);
